<template>
<el-col :span="9" :offset="4">
	<h4 style="margin: 1.5rem 0 2.2rem 0;"> COLOR: </h4>	
	<el-row style="border-radius: 4px; padding: 2px; display:flex; flex-wrap: wrap; justify-content: center" v-bind:class="[ isSelectColor === false ? 'borderGray': 'borderOrange']">
		<div v-for="(circle, index) in bgColors" :key="index" style=" display:flex; align-items: center; padding: 2px">
		  <el-button class="clasBtnCircle" :ref="`btn${index}`" circle @click="pressedButton(circle, index)" v-bind:style="{ backgroundColor: circle.color, width: circle.widthAndHeight, height: circle.widthAndHeight, border: circle.border }" style="display: flex; justify-content: center"></el-button>
		</div> 
	</el-row>
</el-col>
</template>

<script>
    export default {
        name: 'BackgroundSelector',
        props: [
            'changeStatusColor'
        ],
        data() {
            return {
				bgColors: [
					{color: '#9FC5E8', border: '1px solid #134F5C'}, //azul
					{color: '#A2C4C9', border: '1px solid #0B5394'}, //celeste
					{color: '#B4A7D6', border: '1px solid #20124D'}, //morado
					{color: '#B6D7A8', border: '1px solid #274E13'}, //verde
					{color: '#D5A6BD', border: '1px solid #4C1130'}, //lila
					{color: '#EA9999', border: '1px solid #990000'}, //rojo
					{color: '#F9CB9C', border: '1px solid #ff9900'}, //naranja
					{color: '#FFE599', border: '1px solid #ffff00'}, //amarillo
					{color: '#FFFFFF', border: '1px solid #eeeeee'}, //blanco
					{color: '#FF5000', border: '1px solid #FF7333'} //naranja intenso
				],
				isSelectColor: false,
            }
        },
        methods: {
            pressedButton (colorPicked, index ) {
				this.changeStatusColor(colorPicked.color)
				this.resetBgColors()
				this.isSelectColor = true
				this.bgColors[index].border = colorPicked.border
				this.bgColors[index].widthAndHeight = '35px'
			},
			resetBgColors() {
				this.isSelectColor = false
				this.bgColors = this.addProperty(this.bgColors)
			},
			addProperty(val) {
				const newArray = val.map((e) => ({
					color: e.color,
					border: e.border,
					widthAndHeight: '20px'
				}))
				return newArray
			}
		},
		created() {
			this.bgColors = this.addProperty(this.bgColors)
		}
    }
</script>